#!/bin/bash

source /opt/migrate-for-gce/functions.sh

GCPDNS_DIR="/opt/migrate-for-gce/gcpdns"
UTIL_SCRIPTS_DIR="/etc/migrate-for-gce/gcpdns"
WICKED_SVC="/etc/wicked"
UBUNTU_NETPLAN="/etc/netplan"

DHCLIENT_SCRIPT="/etc/dhcp/dhclient.d/gcpdns.sh"
if is_ubuntu_family ; then
	DHCLIENT_SCRIPT="/etc/dhcp/dhclient-exit-hooks.d/gcpdns"
elif is_suse ; then
   DHCLIENT_SCRIPT="/etc/sysconfig/network/if-up.d/gcpdns"
fi


CFG=$1
migrate_log "setup-gcp-dns, mode=${CFG}"

if [ "${CFG}" == "iscsi" ] ; then
	. $GCPDNS_DIR/gcpdns-utils
	update_dns_config
elif [ "${CFG}" == "detach" ] ; then
	mkdir -p $UTIL_SCRIPTS_DIR
	cp -f $GCPDNS_DIR/gcpdns-utils ${UTIL_SCRIPTS_DIR}/
	cp -f $GCPDNS_DIR/gcpdns.sh ${UTIL_SCRIPTS_DIR}/
	cp -f $GCPDNS_DIR/gcpdns.sh $DHCLIENT_SCRIPT
	if [ -d ${WICKED_SVC} ] ; then
		install_wicked_script $GCPDNS_DIR/wicked-gcpdns.sh
	fi
	if [ -d ${UBUNTU_NETPLAN} ] ; then
		install_systemd_service $GCPDNS_DIR/migrate-for-gce-gcpdns.service multi-user.target
	fi
	touch /etc/migrate-for-gce/actions/bypass/setup-gcp-dns
elif [ "${CFG}" == "origin" ] ; then
	rm -f $DHCLIENT_SCRIPT
	rm -rf $UTIL_SCRIPTS_DIR
	rm -f /etc/migrate-for-gce/actions/bypass/setup-gcp-dns
	. $GCPDNS_DIR/gcpdns-utils
	restore_dns_config
else
	exit 1
fi

